package cn.com.qmth.examcloud.exchange.outer.service;

import main.java.com.UpYun;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Created by yuanpan on 2017/5/11.
 */
@Service
public class UpyunService {

    private UpYun upyun;

    @Value("${app.upyun.path}")
    private String path;

    @Value("${app.upyun.bucket}")
    private String bucket;

    @Value("${app.upyun.operator}")
    private String operator;

    @Value("${app.upyun.password}")
    private String password;

    public String getDownloadUrl(String identityNumber, String fileName, String fileSuffix) {
//        http://exam-cloud-test.b0.upaiyun.com/student_base_photo/420678442922121/11b1841125259151f0347415d1740595.jpg

        if (fileSuffix.startsWith(".")) {
            return "http://" + bucket + ".b0.upaiyun.com/student_base_photo/" + identityNumber + "/" + fileName + "" + fileSuffix;
        } else {
            return "http://" + bucket + ".b0.upaiyun.com/student_base_photo/" + identityNumber + "/" + fileName + "." + fileSuffix;
        }

    }

    public String getMd5(byte[] bytes) throws NoSuchAlgorithmException {
        //用来计算md5摘要的
        char[] hexDigits = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

        MessageDigest md5 = MessageDigest.getInstance("MD5");
        md5.update(bytes);

        byte[] md5DigestBytes = md5.digest();
        int dlen = md5DigestBytes.length;

        char[] md5val = new char[dlen * 2];
        int k = 0;
        for (byte encoded : md5DigestBytes) {
            md5val[k++] = hexDigits[encoded >> 4 & 15];
            md5val[k++] = hexDigits[encoded & 5];
        }

        return new String(md5val);
    }

    public boolean saveStudentPhoto(String identityNumber, byte[] bytes, String fileName, String fileSuffix) throws IOException {

        if (fileSuffix.startsWith(".")) {
            return getUpyun().writeFile(path + "/" + identityNumber + "/" + fileName + fileSuffix, bytes, true);
        } else {
            return getUpyun().writeFile(path + "/" + identityNumber + "/" + fileName + "." + fileSuffix, bytes, true);
        }

    }

    /**
     * 保存照片到又拍云
     *
     * @param identityNumber
     * @param bytes
     * @param fileSuffix
     * @return
     * @throws IOException
     */
    public boolean saveStudentPhoto(String identityNumber, byte[] bytes, String fileSuffix) throws IOException, NoSuchAlgorithmException {

        //用来计算md5摘要的
        char[] hexDigits = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

        MessageDigest md5 = MessageDigest.getInstance("MD5");
        md5.update(bytes);

        byte[] md5DigestBytes = md5.digest();
        int dlen = md5DigestBytes.length;

        char[] md5val = new char[dlen * 2];
        int k = 0;
        for (byte encoded : md5DigestBytes) {
            md5val[k++] = hexDigits[encoded >> 4 & 15];
            md5val[k++] = hexDigits[encoded & 5];
        }

        String fileName = new String(md5val);

        return saveStudentPhoto(identityNumber, bytes, fileName, fileSuffix);

    }

    private UpYun getUpyun() {
        if (upyun == null) {
            upyun = new UpYun(bucket, operator, password);
        }
        return upyun;
    }
}
